package com.realnet.vpspack.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.vpspack.Entity.Coupon;
import com.realnet.vpspack.Services.CouponService ;








@RequestMapping(value = "/Coupon")
 @CrossOrigin("*") 
@RestController
public class CouponController {
	@Autowired
	private CouponService Service;

@Value("${projectPath}")
	private String projectPath;
 








	@PostMapping("/Coupon")
		  public Coupon Savedata(@RequestBody Coupon data) {
		Coupon save = Service.Savedata(data)	;







		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Coupon/{id}")
	public  Coupon update(@RequestBody Coupon data,@PathVariable Integer id ) {
		Coupon update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Coupon/getall/page")
	public Page<Coupon> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Coupon> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Coupon")
	public List<Coupon> getdetails() {
		 List<Coupon> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Coupon")
	public List<Coupon> getallwioutsec() {
		 List<Coupon> get = Service.getdetails();		
		return get;
}
@GetMapping("/Coupon/{id}")
	public  Coupon  getdetailsbyId(@PathVariable Integer id ) {
		Coupon  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Coupon/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}









}